#pragma once

#include "CoreMinimal.h"
#include "Skill.h"
#include "EStalkerClassSkillPhase.h"
#include "StalkerClassSkill.generated.h"

class UChargeableComponent;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class CALAMARI_API UStalkerClassSkill : public USkill
{
	GENERATED_BODY()

private:
	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, ReplicatedUsing=OnRep_CooldownChargeableComponent, Transient, Instanced, meta=(AllowPrivateAccess=true))
	UChargeableComponent* _cooldownChargeableComponent;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Replicated, Transient, meta=(AllowPrivateAccess=true))
	EStalkerClassSkillPhase _phase;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_CooldownChargeableComponent();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UStalkerClassSkill();
};

FORCEINLINE uint32 GetTypeHash(const UStalkerClassSkill) { return 0; }
